<?php

namespace Lc\CaracoleBundle\Container\Config;

use Lc\CaracoleBundle\Factory\Config\UnitFactory;
use Lc\CaracoleBundle\Repository\Config\UnitRepositoryQuery;
use Lc\CaracoleBundle\Repository\Config\UnitStore;

class UnitContainer
{
    protected UnitFactory $factory;
    protected UnitRepositoryQuery $repositoryQuery;
    protected UnitStore $store;

    public function __construct(
            UnitFactory $factory,
            UnitRepositoryQuery $repositoryQuery,
            UnitStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): UnitFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): UnitRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): UnitStore
    {
        return $this->store;
    }
}
