<?php

namespace Lc\CaracoleBundle\Container\Order;

use Lc\CaracoleBundle\Factory\Order\OrderProductReductionCatalogFactory;
use Lc\CaracoleBundle\Repository\Order\OrderProductReductionCatalogRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderProductReductionCatalogStore;
use Lc\CaracoleBundle\Solver\Order\OrderProductReductionCatalogSolver;

class OrderProductReductionCatalogContainer
{
    protected OrderProductReductionCatalogFactory $factory;
    protected OrderProductReductionCatalogSolver $solver;
    protected OrderProductReductionCatalogRepositoryQuery $repositoryQuery;
    protected OrderProductReductionCatalogStore $store;

    public function __construct(
            OrderProductReductionCatalogFactory $factory,
            OrderProductReductionCatalogSolver $solver,
            OrderProductReductionCatalogRepositoryQuery $repositoryQuery,
            OrderProductReductionCatalogStore $store
    ) {
        $this->factory = $factory;
        $this->solver = $solver;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): OrderProductReductionCatalogFactory
    {
        return $this->factory;
    }

    public function getSolver(): OrderProductReductionCatalogSolver
    {
        return $this->solver;
    }

    public function getRepositoryQuery(): OrderProductReductionCatalogRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): OrderProductReductionCatalogStore
    {
        return $this->store;
    }

}