<?php

namespace Lc\CaracoleBundle\Container\Order;

use Lc\CaracoleBundle\Factory\Order\OrderProductRefundFactory;
use Lc\CaracoleBundle\Repository\Order\OrderProductRefundRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderProductRefundStore;

class OrderProductRefundContainer
{
    protected OrderProductRefundFactory $factory;
    protected OrderProductRefundRepositoryQuery $repositoryQuery;
    protected OrderProductRefundStore $store;

    public function __construct(
            OrderProductRefundFactory $factory,
            OrderProductRefundRepositoryQuery $repositoryQuery,
            OrderProductRefundStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): OrderProductRefundFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): OrderProductRefundRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): OrderProductRefundStore
    {
        return $this->store;
    }

}