<?php

namespace Lc\CaracoleBundle\Container\Order;

use Lc\CaracoleBundle\Factory\Order\OrderReductionCartFactory;
use Lc\CaracoleBundle\Repository\Order\OrderReductionCartRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderReductionCartStore;

class OrderReductionCartContainer
{
    protected OrderReductionCartFactory $factory;
    protected OrderReductionCartRepositoryQuery $repositoryQuery;
    protected OrderReductionCartStore $store;

    public function __construct(
            OrderReductionCartFactory $factory,
            OrderReductionCartRepositoryQuery $repositoryQuery,
            OrderReductionCartStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): OrderReductionCartFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): OrderReductionCartRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): OrderReductionCartStore
    {
        return $this->store;
    }

}