<?php

namespace Lc\CaracoleBundle\Container\Order;

use Lc\CaracoleBundle\Factory\Order\OrderRefundFactory;
use Lc\CaracoleBundle\Repository\Order\OrderRefundRepositoryQuery;
use Lc\CaracoleBundle\Repository\Order\OrderRefundStore;

class OrderRefundContainer
{
    protected OrderRefundFactory $factory;
    protected OrderRefundRepositoryQuery $repositoryQuery;
    protected OrderRefundStore $store;

    public function __construct(
            OrderRefundFactory $factory,
            OrderRefundRepositoryQuery $repositoryQuery,
            OrderRefundStore $store
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
    }

    public function getFactory(): OrderRefundFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): OrderRefundRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): OrderRefundStore
    {
        return $this->store;
    }

}