<?php

namespace Lc\CaracoleBundle\Container\Product;

use App\Definition\Field\Product\ProductFamilyFieldDefinition;
use Lc\CaracoleBundle\Builder\Product\ProductFamilyBuilder;
use Lc\CaracoleBundle\Factory\Product\ProductFamilyFactory;
use Lc\CaracoleBundle\Repository\Product\ProductFamilyRepositoryQuery;
use Lc\CaracoleBundle\Repository\Product\ProductFamilyStore;
use Lc\CaracoleBundle\Resolver\ProductFamilyResolver;
use Lc\CaracoleBundle\Solver\Product\ProductFamilySolver;

class ProductFamilyContainer
{
    protected ProductFamilyFactory $factory;
    protected ProductFamilySolver $solver;
    protected ProductFamilyRepositoryQuery $repositoryQuery;
    protected ProductFamilyStore $store;
    protected ProductFamilyBuilder $builder;
    protected ProductFamilyResolver $resolver;
    protected ProductFamilyFieldDefinition $fieldDefinition;

    public function __construct(
            ProductFamilyFactory $factory,
            ProductFamilySolver $solver,
            ProductFamilyRepositoryQuery $repositoryQuery,
            ProductFamilyStore $store,
            ProductFamilyBuilder $builder,
            ProductFamilyResolver $resolver,
            ProductFamilyFieldDefinition $fieldDefinition
    ) {
        $this->factory = $factory;
        $this->solver = $solver;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->builder = $builder;
        $this->resolver = $resolver;
        $this->fieldDefinition = $fieldDefinition;
    }

    public function getFactory(): ProductFamilyFactory
    {
        return $this->factory;
    }

    public function getSolver(): ProductFamilySolver
    {
        return $this->solver;
    }

    public function getRepositoryQuery(): ProductFamilyRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): ProductFamilyStore
    {
        $this->store->resetContext();

        return $this->store;
    }

    public function getResolver(): ProductFamilyResolver
    {
        return $this->resolver;
    }

    public function getBuilder(): ProductFamilyBuilder
    {
        return $this->builder;
    }


    public function getFieldDefinition(): ProductFamilyFieldDefinition
    {
        return $this->fieldDefinition;
    }
}
