<?php

namespace Lc\CaracoleBundle\Container\Reduction;

use Lc\CaracoleBundle\Definition\Field\Reduction\ReductionCartFieldDefinition;
use Lc\CaracoleBundle\Factory\Reduction\ReductionCartFactory;
use Lc\CaracoleBundle\Repository\Reduction\ReductionCartRepositoryQuery;
use Lc\CaracoleBundle\Repository\Reduction\ReductionCartStore;

class ReductionCartContainer
{
    protected ReductionCartFactory $factory;
    protected ReductionCartRepositoryQuery $repositoryQuery;
    protected ReductionCartStore $store;
    protected ReductionCartFieldDefinition $fieldDefinition;

    public function __construct(
            ReductionCartFactory $factory,
            ReductionCartRepositoryQuery $repositoryQuery,
            ReductionCartStore $store,
            ReductionCartFieldDefinition $fieldDefinition
    ) {
        $this->factory = $factory;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->fieldDefinition = $fieldDefinition;
    }

    public function getFactory(): ReductionCartFactory
    {
        return $this->factory;
    }

    public function getRepositoryQuery(): ReductionCartRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): ReductionCartStore
    {
        $this->store->resetContext();

        return $this->store;
    }

    public function getFieldDefinition(): ReductionCartFieldDefinition
    {
        return $this->fieldDefinition;
    }
}