<?php

namespace Lc\CaracoleBundle\Container\Setting;

use Lc\CaracoleBundle\Definition\MerchantSettingDefinition;
use Lc\CaracoleBundle\Factory\Setting\MerchantSettingFactory;
use Lc\CaracoleBundle\Repository\Setting\MerchantSettingRepositoryQuery;
use Lc\CaracoleBundle\Repository\Setting\MerchantSettingStore;
use Lc\SovBundle\Solver\Setting\SettingSolver;

class MerchantSettingContainer
{
    protected MerchantSettingFactory $factory;
    protected MerchantSettingDefinition $definition;
    protected MerchantSettingRepositoryQuery $repositoryQuery;
    protected MerchantSettingStore $store;
    protected SettingSolver $settingSolver;

    public function __construct(
            MerchantSettingFactory $factory,
            MerchantSettingDefinition $definition,
            MerchantSettingRepositoryQuery $repositoryQuery,
            MerchantSettingStore $store,
            SettingSolver $settingSolver
    ) {
        $this->factory = $factory;
        $this->definition = $definition;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->settingSolver = $settingSolver;
    }

    public function getFactory(): MerchantSettingFactory
    {
        return $this->factory;
    }

    public function getDefinition(): MerchantSettingDefinition
    {
        return $this->definition;
    }

    public function getRepositoryQuery(): MerchantSettingRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): MerchantSettingStore
    {
        $this->store->resetContext();

        return $this->store;
    }

    public function getSettingSolver(): SettingSolver
    {
        return $this->settingSolver;
    }

}