<?php

namespace Lc\CaracoleBundle\Controller\PointSale;

use Lc\CaracoleBundle\Container\PointSale\PointSaleContainer;
use Lc\CaracoleBundle\Controller\AdminControllerTrait;
use Lc\SovBundle\Controller\AbstractAdminController;
use Lc\SovBundle\Repository\RepositoryQueryInterface;

abstract class PointSaleAdminController extends AbstractAdminController
{
    use AdminControllerTrait;

    public function getRepositoryQuery() :RepositoryQueryInterface
    {
        return $this->get(PointSaleContainer::class)->getRepositoryQuery();
    }

    public function configureFields(string $pageName): iterable
    {
        return $this->getPointSaleContainer()
                ->getFieldDefinition()
                ->getFields($pageName);
    }

    public function createEntity(string $entityFqcn)
    {
        return $this->get(PointSaleContainer::class)
                ->getFactory()
                ->create($this->getMerchantCurrent());
    }
}
