<?php

namespace Lc\CaracoleBundle\Event\Order;

use Lc\CaracoleBundle\Model\Order\OrderShopInterface;
use Lc\CaracoleBundle\Model\Order\OrderStatusInterface;
use Symfony\Contracts\EventDispatcher\Event;

class OrderShopChangeStatusEvent extends Event
{
    const PRE_CHANGE_STATUS = 'order_shop_event.pre_change_status';
    const POST_CHANGE_STATUS = 'order_shop_event.post_change_status';

    protected OrderShopInterface $orderShop;
    protected OrderStatusInterface $orderStatus;
    protected bool $forceByAdmin;

    public function __construct(OrderShopInterface $orderShop, OrderStatusInterface $orderStatus, bool $forceByAdmin)
    {
        $this->orderShop = $orderShop;
        $this->orderStatus = $orderStatus;
        $this->forceByAdmin = $forceByAdmin;
    }

    public function getOrderShop()
    {
        return $this->orderShop;
    }

    public function getOrderStatus()
    {
        return $this->orderStatus;
    }

    public function getForceByAdmin()
    {
        return $this->forceByAdmin;
    }
}
