<?php

namespace Lc\CaracoleBundle\Factory\Reminder;

use App\Entity\Merchant\Merchant;
use Lc\CaracoleBundle\Context\MerchantContextTrait;
use Lc\CaracoleBundle\Context\SectionContextTrait;
use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Factory\Reminder\ReminderFactory as SovReminderFactory;
use Lc\SovBundle\Model\Reminder\ReminderInterface;

class ReminderFactory extends SovReminderFactory
{
    use MerchantContextTrait;
    use SectionContextTrait;

    public function create(
            string $crudAction = null,
            string $crudControllerFqcn = null,
            int $entityId = null
    ): ReminderInterface {

        $reminder = parent::create($crudAction, $crudControllerFqcn, $entityId);

        $reminder->setMerchant($this->merchant);
        $reminder->setSection($this->section);

        return $reminder;
    }

}
