<?php

namespace Lc\CaracoleBundle\Factory\Setting;

use App\Entity\Setting\SectionSetting;
use Lc\CaracoleBundle\Context\SectionContextTrait;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Factory\AbstractFactory;
use Lc\SovBundle\Model\File\FileInterface;

class SectionSettingFactory extends AbstractFactory
{

    public function create(
            SectionInterface $section,
            string $name,
            string $text = null,
            \DateTime $date = null,
            FileInterface $file = null
    ) {
        $merchantSetting = new SectionSetting();

        $merchantSetting->setSection($section);
        $merchantSetting->setName($name);
        $merchantSetting->setText($text);
        $merchantSetting->setDate($date);
        $merchantSetting->setFile($file);

        return $merchantSetting;
    }
}
