<?php

namespace Lc\CaracoleBundle\Factory\Site;

use Lc\CaracoleBundle\Context\MerchantContextTrait;
use Lc\CaracoleBundle\Context\SectionContextTrait;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Factory\Site\PageFactory as SovPageFactory;
use Lc\SovBundle\Model\Site\PageInterface;

class PageFactory extends SovPageFactory
{
    use MerchantContextTrait;
    use SectionContextTrait;

    public function create(): PageInterface
    {
        $page = parent::create();

        $page->setMerchant($this->merchant);

        if(!is_null($this->section)) {
            $page->setSection($this->section);
        }

        return $page;
    }
}
