<?php

namespace Lc\CaracoleBundle\Field\Filter\Order;

use Doctrine\ORM\EntityRepository;
use Doctrine\ORM\QueryBuilder;
use EasyCorp\Bundle\EasyAdminBundle\Dto\FieldDto;
use Lc\SovBundle\Field\Filter\AssociationFilter;
use Lc\SovBundle\Field\Filter\FilterTrait;
use Lc\SovBundle\Repository\RepositoryQueryInterface;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;

/**
 * @author La clic ! <contact@laclic.fr>
 */
class OrderShopDistributionFilter
{
    use FilterTrait;

    public function buildProperty(FormBuilderInterface $builder, FieldDto $fieldDto, $options = array())
    {
        $builder->add(
            $this->getFieldPropertySnake($fieldDto->getProperty()),
            TextType::class,
            array(
                'required' => false,
                'attr' => array(
                    'class' => ' input-sm',
                    'form' => 'filters-form',
                ),
            )
        );
    }

    public function applyFilter(RepositoryQueryInterface $repositoryQuery, FieldDto $fieldDto, $filteredValue = null)
    {
        if ($filteredValue !== null) {
            $cycleType = "week";
            $year = date("Y");

            $filteredValue = strtolower($filteredValue);

            if (str_contains($filteredValue, 'j')) {
                $cycleType = "day";
            } elseif (str_contains($filteredValue, 'm')) {
                $cycleType = "month";
            }
            //On enleve le premier Caractere
            if (preg_match('#^[a-z]#', $filteredValue)) {
                $filteredValue = substr($filteredValue, 1);
            }
            // On sépare le cycleNumber et Year
            $cycleExplode = explode("a", $filteredValue);
            if (!empty($cycleExplode[0])) {
                $cycleNumber = $cycleExplode[0];
            } else {
                $cycleNumber = 0;
            }
            if (isset($cycleExplode[1])) {
                $year = $cycleExplode[1];
                if (strlen($year) == 2) {
                    $year = "20" . $year;
                }
            }

            $repositoryQuery->filterByDistributionData($cycleType, $cycleNumber, $year);
        }
    }

}
