<?php

namespace Lc\CaracoleBundle\Form\Reduction;

use Lc\CaracoleBundle\Model\Config\TaxRateModel;
use Lc\SovBundle\Translation\TranslatorAdmin;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormEvent;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\OptionsResolver\OptionsResolver;

class BehaviorTaxRateType extends AbstractType
{
    protected TranslatorAdmin $translatorAdmin;
    public function __construct(TranslatorAdmin $translatorAdmin)
    {
            $this->translatorAdmin = $translatorAdmin;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
        {
                $builder->addEventListener(FormEvents::PRE_SET_DATA, function (FormEvent $event) {
                        $builder = $event->getForm()->getParent();

                        $builder->add('behaviorTaxRate', ChoiceType::class, [
                                'required' => false,
                                'empty_data' => TaxRateModel::BEHAVIOR_TAX_RATE_INCLUDED,
                                'choices' => $this->translatorAdmin->transChoices(
                                        TaxRateModel::getBehaviorTaxRateChoices(),
                                        'TaxRate',
                                        'behaviorTaxRate'
                                )
                        ]);
                });
        }
}
