<?php

namespace Lc\CaracoleBundle\Form\User;

use App\Entity\User\User;
use Lc\CaracoleBundle\Model\User\UserMerchantInterface;
use Lc\CaracoleBundle\Repository\User\UserStore;
use Lc\SovBundle\Definition\RolesDefinitionInterface;
use Lc\SovBundle\Doctrine\EntityManager;
use Lc\SovBundle\Model\User\UserInterface;
use Lc\SovBundle\Translation\TranslatorAdmin;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\CheckboxType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\EmailType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Security\Core\Authorization\AuthorizationCheckerInterface;

use function Symfony\Component\Translation\t;

class UserMerchantActiveCreditFormType extends AbstractType
{
    protected EntityManager $entityManager;
    protected UserStore $userStore;
    protected TranslatorAdmin $translatorAdmin;


    public function __construct(
            EntityManager $entityManager,
            TranslatorAdmin $translatorAdmin,
            UserStore $userStore
    ) {
        $this->entityManager = $entityManager;
        $this->translatorAdmin = $translatorAdmin;
        $this->userStore = $userStore;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {

        $builder->add(
                'user',
                EntityType::class,
                array(
                        'class'=>  $this->entityManager->getEntityName(UserInterface::class),
                    'choices'=> $this->userStore->setMerchant($options['merchant'])->get()
                )

        );


        $builder->add(
                'submit',
                SubmitType::class,
                [
                        'label' => $this->translatorAdmin->transAction('save'),
                ]
        );
    }

    /**
     * {@inheritdoc}
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults(
                [
                        'data_class' => $this->entityManager->getEntityName(UserMerchantInterface::class),
                        'merchant' => null,
                ]
        );
    }
}
