<?php

namespace Lc\CaracoleBundle\Model\Address;

use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\PointSale\PointSaleInterface;
use Lc\SovBundle\Model\User\UserInterface;

interface AddressInterface
{
    public function getUser(): ?UserInterface;

    public function setUser(?UserInterface $user): AddressModel;

    public function getTitle(): ?string;

    public function setTitle(string $title): AddressModel;

    public function getType(): ?string;

    public function setType(string $type): AddressModel;

    public function getCivility(): ?bool;

    public function setCivility(?bool $civility): AddressModel;

    public function getLastname(): ?string;

    public function setLastname(?string $lastname): AddressModel;

    public function getFirstname(): ?string;

    public function setFirstname(?string $firstname): AddressModel;

    public function getAddress(): ?string;

    public function setAddress(string $address): AddressModel;

    public function getZip(): ?string;

    public function setZip(string $zip): AddressModel;

    public function getCity(): ?string;

    public function setCity(string $city): AddressModel;

    public function getCountry(): ?string;

    public function setCountry(string $country): AddressModel;

    public function getLatitude(): ?string;

    public function setLatitude(?string $latitude): AddressModel;

    public function getLongitude(): ?string;

    public function setLongitude(?string $longitude): AddressModel;

    public function getLatitudeOverride(): ?string;

    public function setLatitudeOverride(?string $latitudeOverride): AddressModel;

    public function getLongitudeOverride(): ?string;

    public function setLongitudeOverride(?string $longitudeOverride): AddressModel;

    public function getCompany(): ?string;

    public function setCompany(?string $company): AddressModel;

    public function getSiret(): ?string;

    public function setSiret(?string $siret): AddressModel;

    public function getTva(): ?string;

    public function setTva(?string $tva): AddressModel;

    public function getPhone(): ?array;

    public function setPhone(?array $phone): AddressModel;

    public function getComment(): ?string;

    public function setComment(?string $comment): AddressModel;

    public function getPointSale(): ?PointSaleInterface;

    public function setPointSale(PointSaleInterface $pointSale): AddressModel;

    public function getMerchant(): ?MerchantInterface;

    public function setMerchant(MerchantInterface $merchant): AddressModel;

    public function getDeliveryInfos(): ?string;

    public function setDeliveryInfos(?string $deliveryInfos): AddressModel;
}