<?php

namespace Lc\CaracoleBundle\Model\Config;

use Doctrine\ORM\Mapping as ORM;
use Lc\SovBundle\Doctrine\Pattern\AbstractLightEntity;

/**
 * @ORM\MappedSuperclass()
 */
abstract class TaxRateModel extends AbstractLightEntity implements TaxRateInterface
{

    const BEHAVIOR_TAX_RATE_INCLUDED = 'tax-included';
    const BEHAVIOR_TAX_RATE_EXCLUDED = 'tax-excluded';

    public function getBehaviorTaxRateChoices(): array
    {
        return [
                self::BEHAVIOR_TAX_RATE_EXCLUDED,
                self::BEHAVIOR_TAX_RATE_INCLUDED,
        ];
    }


    /**
     * @ORM\Column(type="string", length=255)
     */
    protected $title;

    /**
     * @ORM\Column(type="float")
     */
    protected $value;


    public function __toString()
    {
        return $this->getTitle();
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getValue(): ?float
    {
        return $this->value;
    }

    public function setValue(float $value): self
    {
        $this->value = $value;

        return $this;
    }
}
