<?php

namespace Lc\CaracoleBundle\Model\Product;

use App\Entity\Product\ProductFamily;
use App\Entity\Section\Section;
use Doctrine\ORM\Mapping as ORM;
use Lc\SovBundle\Doctrine\EntityInterface;
use Lc\SovBundle\Doctrine\Extension\StatusInterface;
use Lc\SovBundle\Doctrine\Extension\StatusTrait;


/**
 * @ORM\MappedSuperclass()
 */
abstract class ProductFamilySectionPropertyModel implements EntityInterface, ProductFamilySectionPropertyInterface, StatusInterface
{
    use StatusTrait;

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Section\SectionInterface", inversedBy="productFamilySectionProperties")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $section;

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Product\ProductFamilyInterface", inversedBy="productFamilySectionProperties")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $productFamily;


    public function getSection(): ?Section
    {
        return $this->section;
    }

    public function setSection(?Section $section): self
    {
        $this->section = $section;

        return $this;
    }

    public function getProductFamily(): ?ProductFamily
    {
        return $this->productFamily;
    }

    public function setProductFamily(?ProductFamily $productFamily): self
    {
        $this->productFamily = $productFamily;

        return $this;
    }



}
