<?php

namespace Lc\CaracoleBundle\Model\Ticket;

use Doctrine\ORM\Mapping as ORM;
use Lc\CaracoleBundle\Doctrine\Extension\FilterMerchantInterface;
use Lc\CaracoleBundle\Doctrine\Extension\FilterSectionInterface;
use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;
use Lc\CaracoleBundle\Model\Order\OrderShopInterface;
use Lc\CaracoleBundle\Model\Section\SectionInterface;
use Lc\SovBundle\Model\Ticket\TicketModel as SovTicketModel;

/**
 * @ORM\MappedSuperclass()
 */
abstract class TicketModel extends SovTicketModel implements FilterSectionInterface, FilterMerchantInterface
{
    const TYPE_PRODUCT_UNAVAILABLE = 'product-unavailable';
    const TYPE_PRODUCT_ERROR = 'product-error';

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Section\SectionInterface")
     * @ORM\JoinColumn(nullable=true)
     */
    protected $section;

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Merchant\MerchantInterface")
     * @ORM\JoinColumn(nullable=false)
     */
    protected $merchant;

    /**
     * @ORM\ManyToOne(targetEntity="Lc\CaracoleBundle\Model\Order\OrderShopInterface", inversedBy="tickets")
     */
    protected $orderShop;

    public function getSection(): ? SectionInterface
    {
        return $this->section;
    }

    public function setSection(? SectionInterface $section): self
    {
        $this->section = $section;

        return $this;
    }


    public function getMerchant(): MerchantInterface
    {
        return $this->merchant;
    }

    public function setMerchant( MerchantInterface $merchant): self
    {
        $this->merchant = $merchant;

        return $this;
    }

    public function getOrderShop(): ?OrderShopInterface
    {
        return $this->orderShop;
    }

    public function setOrderShop(OrderShopInterface $orderShop): self
    {
        $this->orderShop = $orderShop;

        return $this;
    }

}
