<?php

namespace Lc\CaracoleBundle\Repository\Order;

use Lc\CaracoleBundle\Repository\AbstractStore;
use Lc\SovBundle\Repository\RepositoryQueryInterface;

class OrderStatusStore extends AbstractStore
{
    protected OrderStatusRepositoryQuery $query;

    public function __construct(OrderStatusRepositoryQuery $query)
    {
        $this->query = $query;
    }

    public function orderByDefault(RepositoryQueryInterface $query): RepositoryQueryInterface
    {
        $query->orderBy('id');
        return $query;
    }

    public function filtersDefault(RepositoryQueryInterface $query): RepositoryQueryInterface
    {
        return $query;
    }

    public function relationsDefault(RepositoryQueryInterface $query): RepositoryQueryInterface
    {
        return $query;
    }

    public function getOneByAlias(string $alias, $query = null)
    {
        $query = $this->createDefaultQuery($query);
        $query->filterByAlias($alias);
        return $query->findOne();
    }
}
