<?php

namespace Lc\CaracoleBundle\Repository\Product;

use Knp\Component\Pager\PaginatorInterface;
use Lc\CaracoleBundle\Model\Product\ProductFamilyInterface;
use Lc\CaracoleBundle\Repository\SectionRepositoryQueryTrait;
use Lc\SovBundle\Repository\AbstractRepositoryQuery;

class ProductFamilySectionPropertyRepositoryQuery extends AbstractRepositoryQuery
{
    use SectionRepositoryQueryTrait;

    public function __construct(ProductFamilySectionPropertyRepository $repository, PaginatorInterface $paginator)
    {
        parent::__construct($repository, 'productFamilySectionProperty', $paginator);
    }

    public function filterByProductFamily(ProductFamilyInterface $productFamily): self
    {
        return $this->andWhereEqual('productFamily', $productFamily);
    }

}
