<?php

namespace Lc\CaracoleBundle\Solver\Merchant;

use Lc\CaracoleBundle\Model\Merchant\MerchantInterface;

class MerchantSolver
{
    public function getNewsletters(MerchantInterface $merchant): array
    {
        $newsletterArray = [];

        foreach($merchant->getSections() as $section) {
            foreach($section->getNewsletters() as $newsletter) {
                $newsletterArray[] = $newsletter;
            }
        }

        return $newsletterArray;
    }

    public function getSectionsOnline(MerchantInterface $merchant):array{
        $sectionArray = [];

        foreach($merchant->getSections() as $section) {
             if($section->getStatus() == 1){
                 $sectionArray[] = $section;
            }
        }

        return $sectionArray;
    }
}
